stages:
  - prepare
  - build
  - test
  - deploy

install:
  stage: prepare
  image: node:16
  script:
    - npm install
  artifacts:
    paths:
      - node_modules

build:
  stage: build
  rules:
    - if: $CI_PROJECT_NAMESPACE == "latency.gg" && $CI_COMMIT_TAG =~ /^v/
  image: node:16
  dependencies: [install]
  script:
    - TAG=$CI_COMMIT_TAG PACKAGE_NAME=@$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME make
  artifacts:
    paths:
      - out

test:
  stage: test
  image: node:16
  dependencies: [install]
  script:
    - ./test

deploy-npm:
  stage: deploy
  rules:
    - if: $CI_PROJECT_NAMESPACE == "latency.gg" && $CI_COMMIT_TAG =~ /^v/
  image: node:16
  dependencies: [install, build]
  script:
    - echo "@${CI_PROJECT_ROOT_NAMESPACE}:registry=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/npm/" >> ~/.npmrc
    - echo "${CI_API_V4_URL#https?}/projects/${CI_PROJECT_ID}/packages/npm/:_authToken=\${CI_JOB_TOKEN}" >> ~/.npmrc
    - ( cd out/npm ; npm publish )
